class GreenMonsterSpawnEffect expands UTTeleportEffect;

var UTTeleEffectGreen T1, T2;

simulated event PostNetBeginPlay()
{
	super.PostNetBeginPlay();
	WetTexture'utflare_green1'.Palette = Texture'Green'.Palette;
	WetTexture'utflare_green2'.Palette = Texture'Green'.Palette;
	WetTexture'utflare_green3'.Palette = Texture'Green'.Palette;
	WetTexture'utflare_green4'.Palette = Texture'Green'.Palette;
	WetTexture'utflare_green5'.Palette = Texture'Green'.Palette;
	WetTexture'utflare_green6'.Palette = Texture'Green'.Palette;
	WetTexture'utflare_green7'.Palette = Texture'Green'.Palette;
	WetTexture'utflare_green8'.Palette = Texture'Green'.Palette;
}

function PostBeginPlay()
{
	WetTexture'utflare_green1'.Palette = Texture'Green'.Palette;
	WetTexture'utflare_green2'.Palette = Texture'Green'.Palette;
	WetTexture'utflare_green3'.Palette = Texture'Green'.Palette;
	WetTexture'utflare_green4'.Palette = Texture'Green'.Palette;
	WetTexture'utflare_green5'.Palette = Texture'Green'.Palette;
	WetTexture'utflare_green6'.Palette = Texture'Green'.Palette;
	WetTexture'utflare_green7'.Palette = Texture'Green'.Palette;
	WetTexture'utflare_green8'.Palette = Texture'Green'.Palette;
}

auto state Explode
{
	simulated function Tick(float DeltaTime)
	{
		local rotator newrot;

		if ( !Level.bHighDetailMode )
		{
			bOwnerNoSee = true;
			Disable('Tick');
			return;
		}

		if ( Level.NetMode == NM_DedicatedServer )
		{
			Disable('Tick');
			return;
		}

		ScaleGlow = (Lifespan/Default.Lifespan);	
		LightBrightness = ScaleGlow*210.0;

		if ( !Level.bHighDetailMode )
		{
			LightRadius = 6;
			return;
		}

		if ( !bSpawnEffects )
		{
			bSpawnEffects = true;
			T1 = spawn(class'UTTeleEffectGreen');
			newrot = Rotation;
			newRot.Yaw = Rand(65535);
			T2 = spawn(class'UTTeleEffectGreen',,,location - vect(0,0,10), newRot);
		}
		else
		{
			if ( T1 != None )
				T1.ScaleGlow = ScaleGlow;
			if ( T2 != None )
				T2.ScaleGlow = ScaleGlow;
		}
	}
}

defaultproperties
{
     Texture=Texture'utflare_green1'
     Skin=Texture'UnrealShare.DispExpl.DISE_A01'
     LightHue=64
     LightSaturation=0
     LODBias=20
     MultiSkins(0)=Texture'utflare_green1'
     MultiSkins(1)=Texture'utflare_green2'
     MultiSkins(2)=Texture'utflare_green3'
     MultiSkins(3)=Texture'utflare_green4'
     MultiSkins(4)=Texture'utflare_green5'
     MultiSkins(5)=Texture'utflare_green6'
     MultiSkins(6)=Texture'utflare_green7'
     MultiSkins(7)=Texture'utflare_green8'
}
