class MMRedBallExplosion expands BallExplosion;

simulated function Tick( float DeltaTime )
{
	if ( Level.NetMode != NM_DedicatedServer )
		LightBrightness = Max( LightBrightness - 250*DeltaTime, 0 );
}

simulated function PostBeginPlay()
{
	PlayAnim  ( 'Explo', 0.6 );
	MakeSound();
	Super.PostBeginPlay();
}

function MakeSound()
{
	PlaySound (EffectSound1);
	MakeNoise ( 1.0 );
}

simulated function AnimEnd()
{
	Destroy();
}

defaultproperties
{
     Style=STY_Translucent
     Sprite=FireTexture'FireEffectRed'
     Texture=FireTexture'FireEffectRed'
     Skin=FireTexture'FireEffectRed'
     ScaleGlow=0.500000
     bUnlit=True
     MultiSkins(0)=FireTexture'FireEffectRed'
     MultiSkins(1)=FireTexture'FireEffectRed'
     MultiSkins(2)=FireTexture'FireEffectRed'
     MultiSkins(3)=FireTexture'FireEffectRed'
     MultiSkins(4)=FireTexture'FireEffectRed'
     MultiSkins(5)=FireTexture'FireEffectRed'
     MultiSkins(6)=FireTexture'FireEffectRed'
     MultiSkins(7)=FireTexture'FireEffectRed'
     LightHue=0
     LightSaturation=0
}
