class MM_AncientGuard extends  AncientGuard
     config(MM_AncientGuard);

var() byte meleeteamvaluemonster;
var() byte Team;
var() config bool bHateOurOwn;
var() config bool bRespawn;
var MMMonsterStart startPoint;
var MonstermadnessMsgDelay msgDelayer;
var() config float RespawnDelay;
var() byte scorevalue;

var() texture redteamskin;
var() texture multiskinsredteam[8];
var() texture blueteamskin;
var() texture multiskinsblueteam[8];
var() texture zombieblueteamskin;
var() texture zombieredteamskin;
var() texture zombieskin;
var() texture meanzombieskin;

var() config bool bZombie;
var() config float zombiechance;

simulated event PostNetBeginPlay()
{
	super.PostNetBeginPlay();
	WetTexture'RedKrallAncientGuard'.Palette = Texture'DeepRed'.Palette;
	WetTexture'BlueKrallAncientGuard'.Palette = Texture'DeepBlue'.Palette;
}

function PreBeginPlay()
{
	local MM_Mutator dmtMutator;
	local bool bMutatorSpawned;
	local int iNameNumber;
	local string MyNewName;
	local float Selection;

	bIsPlayer = true;
	Super.PreBeginPlay();

if (brespawn)

{
	startPoint = spawn(class'MMMonsterStart', self, , 
			Location, Rotation);
	if(startPoint == None)
	{
		Log(class$":PreBeginPlay : Couldn't spawn startPoint.");
	}
}

	bMutatorSpawned = false;
	foreach AllActors(class'MM_Mutator', dmtMutator)
	{
		bMutatorSpawned = true;
	}
	if(!bMutatorSpawned)
	{
		Log(class$":PreBeginPlay : Creating a MM_Mutator.");
		level.game.BaseMutator.AddMutator(Spawn(class'MM_Mutator'));
	}

meleeteamvaluemonster = team;

	if(Level.Game.IsA('TeamGamePlus'))
		PlayerReplicationInfo.Team = Team;
	else
		PlayerReplicationInfo.Team = 255;



	if ( Team == 0 )
	{
		multiSkins[0]=multiskinsredteam[0];
		multiSkins[1]=multiskinsredteam[1];
        multiSkins[2]=multiskinsredteam[2];
        multiSkins[3]=multiskinsredteam[3];
        multiSkins[4]=multiskinsredteam[4];	
		multiSkins[5]=multiskinsredteam[5];
        multiSkins[6]=multiskinsredteam[6];
        multiSkins[7]=multiskinsredteam[7];
		Style = STY_Masked;
        Skin=redteamskin;	
	}
	if ( Team == 1 )
	{
		multiSkins[0]=multiskinsblueteam[0];
		multiSkins[1]=multiskinsblueteam[1];
        multiSkins[2]=multiskinsblueteam[2];
        multiSkins[3]=multiskinsblueteam[3];
        multiSkins[4]=multiskinsblueteam[4];	
		multiSkins[5]=multiskinsblueteam[5];
        multiSkins[6]=multiskinsblueteam[6];
        multiSkins[7]=multiskinsblueteam[7];
		Style = STY_Masked;
        Skin=blueteamskin;	
	}
	if ( Team == 3 )
	{
	}
	SetInventory();
}

function postbeginplay()
{
    local float Selection;

	WetTexture'RedKrallAncientGuard'.Palette = Texture'DeepRed'.Palette;
	WetTexture'BlueKrallAncientGuard'.Palette = Texture'DeepBlue'.Palette;
	
playerreplicationinfo.playername="Ancient Guard";

	if ( Team == 3 )
	{
Selection = FRand();

if ( Selection < 1.0 )
{
dropwhenkilled = (Class'mm_ancientguardammo');
}
}
}

function PlayTakeHit(float tweentime, vector HitLoc, int damage)
{
	local carcass carc;
	local LeglessKrall rep;
	local pawn OtherPawn;
	local Actor A;

	if ( (Health > 30) || (damage < 24) || (HitLoc.Z > Location.Z) || (FRand() < 0.6) || Level.Game.bVeryLowGore )
	{
		Super.PlayTakeHit(tweentime, HitLoc, damage);
		return;
	}

	carc = Spawn(class 'CreatureChunks',,, Location - CollisionHeight * vect(0,0,0.5), Rotation + rot(3000,0,16384) );
	if (carc != None)
	{
		carc.Mesh = mesh'KrallFoot';
		carc.Initfor(self);
		carc.Velocity = Velocity + VSize(Velocity) * VRand();
		carc.Velocity.Z = FMax(carc.Velocity.Z, Velocity.Z);
	}
	carc = Spawn(class 'CreatureChunks',,, Location - CollisionHeight * vect(0,0,0.5), Rotation + rot(3000,0,16384) );
	if (carc != None)
	{
		carc.Mesh = mesh'KrallFoot';
		carc.Initfor(self);
		carc.Velocity = Velocity + VSize(Velocity) * VRand();
		carc.Velocity.Z = FMax(carc.Velocity.Z, Velocity.Z);
	}

	SetCollision(false, false, false);
	OtherPawn = Level.PawnList;
	while ( OtherPawn != None )
	{
		OtherPawn.Killed(enemy, self, '');
		OtherPawn = OtherPawn.nextPawn;
	}
	if ( CarriedDecoration != None )
		DropDecoration();
	if ( Event != '' )
		foreach AllActors( class 'Actor', A, Event )
			A.Trigger( self, enemy );
	Level.Game.DiscardInventory(self);
	Velocity.Z *= 1.3;
	destroy();
}

function PlayHit(float Damage, vector HitLocation, name damageType, vector Momentum)
{
	local float rnd;
	local Bubble1 bub;
	local bool bOptionalTakeHit;
	local vector BloodOffset;
	local Ut_WallHit b;

	if (Damage > 1)
	{
		if (damageType == 'Drowned')
		{
			bub = spawn(class 'Bubble1',,, Location 
				+ 0.7 * CollisionRadius * vector(ViewRotation) + 0.3 * EyeHeight * vect(0,0,1));
			if (bub != None)
				bub.DrawScale = FRand()*0.06+0.04; 
		}
		else if ( damageType != 'Corroded' )
		{
			BloodOffset = 0.2 * CollisionRadius * Normal(HitLocation - Location);
			BloodOffset.Z = BloodOffset.Z * 0.5;
			b = spawn(class 'Ut_WallHit',,,hitLocation + BloodOffset, rotator(BloodOffset));
			
			if ( Level.bHighDetailMode )
			{
				if ( bGreenBlood )
					spawn(class'Ut_WallHit',,, hitLocation + BloodOffset);
				else
					spawn(class'Ut_WallHit',,, hitLocation + BloodOffset);
			}
		}
	}	

	if ( (Weapon != None) && Weapon.bPointing && !bIsPlayer )
	{
		bFire = 0;
		bAltFire = 0;
	}
	
	bOptionalTakeHit = bIsWuss || ( (Level.TimeSeconds - LastPainTime > 0.3 + 0.25 * skill)
						&& (Damage * FRand() > 0.08 * Health) && (Skill < 3)
						&& (GetAnimGroup(AnimSequence) != 'MovingAttack') 
						&& (GetAnimGroup(AnimSequence) != 'Attack') ); 
	if ( (!bIsPlayer || (Weapon == None) || !Weapon.bPointing) 
		&& (bOptionalTakeHit || (Momentum.Z > 140) || (bFirstShot && (Damage > 0.015 * (skill + 6) * Health)) 
			 || (Damage * FRand() > (0.17 + 0.04 * skill) * Health)) ) 
	{
		PlayTakeHitSound(Damage, damageType, 3);
		PlayHitAnim(HitLocation, Damage);
	}
	else if (NextState == 'TakeHit')
	{
		PlayTakeHitSound(Damage, damageType, 2);
		NextState = '';
	}
}

function PlayHitAnim(vector HitLocation, float Damage)
{
	bFirstShot = false;
	NextAnim = ''; 
	NextState = 'TakeHit';
	PlayTakeHit(0.08, hitLocation, Damage); 
} 

function PlayDeathHit(float Damage, vector HitLocation, name damageType, vector Momentum)
{
	local Bubble1 bub;
	local Ut_WallHit b;

	if ( Region.Zone.bDestructive && (Region.Zone.ExitActor != None) )
		Spawn(Region.Zone.ExitActor);
	if (HeadRegion.Zone.bWaterZone)
	{
		bub = spawn(class 'Bubble1',,, Location 
			+ 0.3 * CollisionRadius * vector(Rotation) + 0.8 * EyeHeight * vect(0,0,1));
		if (bub != None)
			bub.DrawScale = FRand()*0.08+0.03; 
		bub = spawn(class 'Bubble1',,, Location 
			+ 0.2 * CollisionRadius * VRand() + 0.7 * EyeHeight * vect(0,0,1));
		if (bub != None)
			bub.DrawScale = FRand()*0.08+0.03; 
		bub = spawn(class 'Bubble1',,, Location 
			+ 0.3 * CollisionRadius * VRand() + 0.6 * EyeHeight * vect(0,0,1));
		if (bub != None)
			bub.DrawScale = FRand()*0.08+0.03; 
	}
	if ( (damageType != 'Burned') && (damageType != 'Corroded') 
		 && (damageType != 'Drowned') && (damageType != 'Fell') )
	{
		b = spawn(class 'Ut_WallHit',self,'', hitLocation);
	}
}

function Died(pawn Killer, name damageType, vector HitLocation)
{
	local string pawnName;
	Super.Died(Killer, damageType, HitLocation);
}

function Killed(pawn Killer, pawn Other, name damageType)
{
	if(self == Killer)
	{
	
	}
	

	Super.Killed(Killer, Other, damageType);
}

function bool RestartTitan( pawn aPlayer )	
{
	local bool foundStart;

	if( startPoint == None )
	{
		log(class$"::RestartPlayer : startPoint = None!");
		return false;
	}

	foundStart = aPlayer.SetLocation(startPoint.Location);
	if( foundStart )
	{
		startPoint.PlayTeleportEffect(aPlayer, true);
		aPlayer.SetRotation(startPoint.Rotation);
		aPlayer.ViewRotation = aPlayer.Rotation;
		aPlayer.Acceleration = vect(0,0,0);
		aPlayer.Velocity = vect(0,0,0);
		aPlayer.Health = aPlayer.Default.Health;
		aPlayer.SetCollision( true, true, true );
		aPlayer.ClientSetLocation( startPoint.Location, startPoint.Rotation );
		aPlayer.bHidden = false;
		aPlayer.DamageScaling = aPlayer.Default.DamageScaling;
		aPlayer.SoundDampening = aPlayer.Default.SoundDampening;
		SetInventory();
	}
	else
		log(startPoint$" Player start not useable!!!");

	return foundStart;
}

state Dying
{
ignores SeePlayer, EnemyNotVisible, HearNoise, Died, Bump, Trigger, HitWall, HeadZoneChange, FootZoneChange, ZoneChange, Falling, WarnTarget, LongFall, SetFall, PainTimer;

	function ReStartPlayer()
	{
		if( bHidden && RestartTitan(self) )
		{
			Velocity = vect(0,0,0);
			Acceleration = vect(0,0,0);
			ViewRotation = Rotation;
			SetPhysics(PHYS_Falling);
			GotoState('Roaming');
		}
		else if ( !IsInState('GameEnded') )
			GotoState('Dying', 'TryAgain');
	}

Begin:
	if ( Level.Game.bGameEnded )
		GotoState('GameEnded');
	Sleep(0.2);

	if(!bRespawn)
		GotoState('Destroying');

	if ( !bHidden )
		SpawnCarcass();
TryAgain:
	if ( !bHidden )
		HidePlayer();
	Sleep(RespawnDelay);
	ReStartPlayer();
	Goto('TryAgain');
WaitingForStart:
	bHidden = true;
}

State Destroying
{
ignores SeePlayer, EnemyNotVisible, HearNoise, KilledBy, Trigger, Bump, HitWall, HeadZoneChange, FootZoneChange, ZoneChange, Falling, WarnTarget, Died, LongFall, PainTimer;

	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
							Vector momentum, name damageType)
	{
		if ( bDeleteMe )
			return;
		Health = Health - Damage;
		Momentum = Momentum/Mass;
		AddVelocity( momentum ); 
		if ( !bHidden && Gibbed(damageType) )
		{
			bHidden = true;
			SpawnGibbedCarcass();
			if ( bIsPlayer )
				HidePlayer();
			else
				Destroy();
		}
	}

	function Timer()
	{
		if ( !bHidden )
		{
			bHidden = true;
			SpawnCarcass();
			if ( bIsPlayer )
				HidePlayer();
			else
				Destroy();
		}
	}

	event Landed(vector HitNormal)
	{
		SetPhysics(PHYS_None);
	}

	function BeginState()
	{
		SetTimer(0.3, false);
	}
}

state GameEnded
{
	ignores SeePlayer, HearNoise, KilledBy, Bump, HitWall, HeadZoneChange, FootZoneChange, ZoneChange, Falling, TakeDamage, WarnTarget, Died;

	function BeginState()
	{	
		local PlayerPawn pp;
		local UnrealScoreBoard usb;
		local String strWinner;

		if(msgDelayer != None)
			msgDelayer.bDisabled = true;

		if(Health >= 0)
		SetPhysics(PHYS_None);
		GotoState('Waiting', 'Begin');
	}
}

function SetInventory()
{
	local Translator s;

	if ( FindInventoryType(class'Translator') != None )
		return;
	s = Spawn(class'Translator',,, Location);
	if (s != None)
	{
		s.bHeldItem = true;
		s.GiveTo( self );
	}

	if(inventory==None)
		Log(class$":SetInventory : No damn inventory!");
}

function bool SetEnemy( Pawn NewEnemy )
{
	local bool result;
	local eAttitude newAttitude, oldAttitude;
	local bool noOldEnemy;
	local float newStrength;

	if(NewEnemy.GetStateName() == 'PlayerWaiting')
	{
		return false;
	}

	if(PlayerReplicationInfo.Team != 255 &&
			PlayerReplicationInfo.Team == NewEnemy.PlayerReplicationInfo.Team)
	{
		return false;
	}

	if ( !bCanWalk && !bCanFly && !NewEnemy.FootRegion.Zone.bWaterZone )
		return false;
	if ( (NewEnemy == Self) || (NewEnemy == None) || (NewEnemy.Health <= 0) )
		return false;
	if ( (PlayerPawn(NewEnemy) == None) && 
		(ScriptedPawn(NewEnemy) == None) && 
		(Bots(NewEnemy) == None) &&
		(Bot(NewEnemy) == None))
		return false;

	noOldEnemy = (Enemy == None);
	result = false;
	newAttitude = AttitudeTo(NewEnemy);
	if ( !noOldEnemy )
	{
		if (Enemy == NewEnemy)
			return true;
		else if ( NewEnemy.bIsPlayer && (AlarmTag != '') )
		{
			OldEnemy = Enemy;
			Enemy = NewEnemy;
			result = true;
		} 
		else if ( newAttitude == ATTITUDE_Friendly )
		{
			if ( bIgnoreFriends )
				return false;
			if ( (NewEnemy.Enemy != None) && (NewEnemy.Enemy.Health > 0) ) 
			{
				if ( NewEnemy.Enemy.bIsPlayer && (NewEnemy.AttitudeToPlayer < AttitudeToPlayer) )
					AttitudeToPlayer = NewEnemy.AttitudeToPlayer;
				if ( AttitudeTo(NewEnemy.Enemy) < AttitudeTo(Enemy) )
				{
					OldEnemy = Enemy;
					Enemy = NewEnemy.Enemy;
					result = true;
				}
			}
		}
		else 
		{
			oldAttitude = AttitudeTo(Enemy);
			if ( (newAttitude < oldAttitude) || 
				( (newAttitude == oldAttitude) 
					&& ((VSize(NewEnemy.Location - Location) < VSize(Enemy.Location - Location)) 
						|| !LineOfSightTo(Enemy)) ) ) 
			{
				if ( bIsPlayer && Enemy.IsA('PlayerPawn') && !NewEnemy.IsA('PlayerPawn') )
				{
					newStrength = relativeStrength(NewEnemy);
					if ( (newStrength < 0.2) && (relativeStrength(Enemy) < FMin(0, newStrength))  
						&& (IsInState('Hunting')) && (Level.TimeSeconds - HuntStartTime < 5) )
						result = false;
					else
					{
						result = true;
						OldEnemy = Enemy;
						Enemy = NewEnemy;
					}
				} 
				else
				{
					result = true;
					OldEnemy = Enemy;
					Enemy = NewEnemy;
				}
			}
		}
	}
	else if ( newAttitude < ATTITUDE_Ignore )
	{
		result = true;
		Enemy = NewEnemy;
	}
	else if ( newAttitude == ATTITUDE_Friendly )
	{	
		if ( NewEnemy.bIsPlayer && (AlarmTag != '') )
		{
			Enemy = NewEnemy;
			result = true;
		} 
		if (bIgnoreFriends)
			return false;

		if ( (NewEnemy.Enemy != None) && (NewEnemy.Enemy.Health > 0) ) 
		{
			result = true;
			Enemy = NewEnemy.Enemy;
			if (Enemy.bIsPlayer)
				AttitudeToPlayer = ScriptedPawn(NewEnemy).AttitudeToPlayer;
			else if ( (ScriptedPawn(NewEnemy) != None) && (ScriptedPawn(NewEnemy).Hated == Enemy) )
				Hated = Enemy;
		}
	}

	if ( result )
	{
		LastSeenPos = Enemy.Location;
		LastSeeingPos = Location;
		EnemyAcquired();
		if ( !bFirstHatePlayer && Enemy.bIsPlayer && (FirstHatePlayerEvent != '') )
			TriggerFirstHate();
	}
	else if ( NewEnemy.bIsPlayer && (NewAttitude < ATTITUDE_Threaten) )
		OldEnemy = NewEnemy;
				
	return result;
}

function eAttitude AttitudeTo(Pawn Other)
{
	if(PlayerReplicationInfo.Team != 255 &&
			PlayerReplicationInfo.Team == Other.PlayerReplicationInfo.Team)
		return ATTITUDE_Friendly;

	if(bHateOurOwn && Other.class == class)
	{
		return ATTITUDE_Hate;
	}

	return Super.AttitudeTo(Other);
}

function BotVoiceMessage(name messagetype, byte MessageID, Pawn Sender)
{
	if ( messagetype == 'ORDER' )
	{	
	}
}

defaultproperties
{
     Team=3
     scorevalue=100
     redteamskin=Texture'RedKrallAncientGuard'
     multiskinsredteam(1)=Texture'RedKrallAncientGuard'
     blueteamskin=Texture'BlueKrallAncientGuard'
     multiskinsblueteam(1)=Texture'BlueKrallAncientGuard'
}
