class MM_BioGel_B extends MM_BioGel;

simulated event PostNetBeginPlay()
{
	super.PostNetBeginPlay();
	WetTexture'BioGel_B'.Palette = Texture'Blue'.Palette;
}

function postbeginplay()
{
	WetTexture'BioGel_B'.Palette = Texture'Blue'.Palette;
}

function Timer()
{
	local ut_BlueGelPuff f;

	f = spawn(class'ut_BlueGelPuff',,,Location + SurfaceNormal*8); 
	f.numBlobs = numBio;
	if ( numBio > 0 )
		f.SurfaceNormal = SurfaceNormal;	
	PlaySound (MiscSound,,3.0*DrawScale);	
	if ( (Mover(Base) != None) && Mover(Base).bDamageTriggered )
		Base.TakeDamage( Damage, instigator, Location, MomentumTransfer * Normal(Velocity), MyDamageType);
	
	HurtRadius(damage * Drawscale, FMin(250, DrawScale * 75), MyDamageType, MomentumTransfer * Drawscale, Location);
	Destroy();	
}
	
simulated function SetWall(vector HitNormal, Actor Wall)
{
	local vector TraceNorm, TraceLoc, Extent;
	local actor HitActor;
	local rotator RandRot;

	SurfaceNormal = HitNormal;
	if ( Level.NetMode != NM_DedicatedServer )
		spawn(class'BioMark_B',,,Location, rotator(SurfaceNormal));
	RandRot = rotator(HitNormal);
	RandRot.Roll += 32768;
	SetRotation(RandRot);	
	if ( Mover(Wall) != None )
		SetBase(Wall);
}

defaultproperties
{
     MultiSkins(1)=Texture'BioGel_B'
     Texture=Texture'BioGel_B'
     Skin=Texture'BioGel_B'
     MultiSkins(0)=Texture'BioGel_B'
     MultiSkins(1)=Texture'BioGel_B'
     MultiSkins(2)=Texture'BioGel_B'
     MultiSkins(3)=Texture'BioGel_B'
     MultiSkins(4)=Texture'BioGel_B'
     MultiSkins(5)=Texture'BioGel_B'
     MultiSkins(6)=Texture'BioGel_B'
     MultiSkins(7)=Texture'BioGel_B'
     LightHue=170
     LightSaturation=32
}
