class MM_BronzeSpeedTool expands MM_BronzeMonsterTool;

event float BotDesireability( pawn Bot )
{
	local inventory Inv;

	for ( Inv=Bot.inventory; Inv!=None; Inv=Inv.inventory )
		if ( Inv.IsA('MM_BronzeSpeedTool') )
			return -1;

	return Super.BotDesireability(Bot);
}

function BeginState()
	{
		bActive = true;
SetTimer(1.0, true);

}
function Timer()
{
	if (pawn(owner).health<0) 

pawn(owner).groundspeed = pawn(owner).default.groundspeed;
Destroy();

}

function ArmorImpactEffect(vector HitLocation)
{ 
	if ( Owner.IsA('PlayerPawn') )
	{
		PlayerPawn(Owner).ClientFlash(-0.05,vect(400,400,400));
		PlayerPawn(Owner).PlaySound(DeActivateSound, SLOT_None, 2.7*PlayerPawn(Owner).SoundDampening);
	}
}

function PickupFunction(Pawn Other)
{
	local Inventory Inv;

        inv = instigator.FindInventoryType(class'MM_BronzeBerserkerTool');
   	 
		if( inv != None )
		{
				inv.destroy();
              PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Bronze' @ 'Berserker' @ 'Tool'$M_DeActivated$ItemName);	
pawn(owner).groundspeed = pawn(owner).default.groundspeed;
		}

        inv = instigator.FindInventoryType(class'MM_BronzeBruteRocketTool');
   	 
		if( inv != None )
		{
				inv.destroy();
               PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Bronze' @ 'Brute' @ 'Rocket' @ 'Tool'$M_DeActivated$ItemName);
pawn(owner).groundspeed = pawn(owner).default.groundspeed;	
		}

        inv = instigator.FindInventoryType(class'MM_BronzeMonsterCreditTool');
   	 
		if( inv != None )
		{
				inv.destroy();
              PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Bronze' @ 'Monster' @ 'Credit' @ 'Tool'$M_DeActivated$ItemName);
pawn(owner).groundspeed = pawn(owner).default.groundspeed;	
		}

        inv = instigator.FindInventoryType(class'MM_BronzeProjectileDamageTool');
   	 
		if( inv != None )
		{
				inv.destroy();
               PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Bronze' @ 'Projectile' @ 'Damage' @ 'Tool'$M_DeActivated$ItemName);	
pawn(owner).groundspeed = pawn(owner).default.groundspeed;
		}

        inv = instigator.FindInventoryType(class'MM_BronzeProjectileSpeedTool');
   	 
		if( inv != None )
		{
				inv.destroy();
              PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Bronze' @ 'Projectile' @ 'Speed' @ 'Tool'$M_DeActivated$ItemName);
pawn(owner).groundspeed = pawn(owner).default.groundspeed;	
		}
        		if( inv == None )
		{
			  Pawn(Owner).ClientMessage(M_Selected$ItemName);	
		}
}

defaultproperties
{
     bAutoActivate=True
     PickupMessage="You picked up the Bronze Speed Tool."
     ItemName="Bronze Speed Tool"
     PlayerViewMesh=LodMesh'UnrealShare.UrnM'
     PlayerViewScale=1.000000
     PickupViewMesh=LodMesh'UnrealShare.UrnM'
     PickupViewScale=1.000000
     Mesh=LodMesh'UnrealShare.UrnM'
     DrawScale=1.000000
     CollisionHeight=20.000000
}
