class MM_MeleeFirstProjectile expands MM_SpawnerProjectile;


var int NumWallHits;
var bool bCanHitInstigator, bHitWater;

	simulated function SetRoll(vector NewVelocity) 
	{
		local rotator newRot;	
	
		newRot = rotator(NewVelocity);	
		SetRotation(newRot);	
	}

	simulated function HitWall (vector HitNormal, actor Wall)
	{
		
		
		PlaySound(ImpactSound, SLOT_Misc, 2.0);
		//LoopAnim('Spin',1.0);
		if ( (Mover(Wall) != None) && Mover(Wall).bDamageTriggered )
		{
			if ( Role == ROLE_Authority )
				Wall.TakeDamage( Damage, instigator, Location, MomentumTransfer * Normal(Velocity), '');
			Destroy();
			return;
		}
		NumWallHits++;
		SetTimer(0, False);
		MakeNoise(0.3);
		if ( NumWallHits > 5 )
			Destroy();
		Velocity -= 2 * ( Velocity dot HitNormal) * HitNormal;  
		SetRoll(Velocity);
	}
auto state Flying
{

simulated function ProcessTouch (Actor Other, Vector HitLocation)
{


	if (Other != instigator)

	{
		if ( Role == ROLE_Authority )
       {
			Other.TakeDamage(Damage, instigator,HitLocation,
					15000.0 * Normal(velocity), 'burned');
		Explode(HitLocation, Vect(0,0,0));
       }
	}

}

simulated function Explode(vector HitLocation, vector HitNormal)
{
    local vector start;

	HurtRadius(damage, BlastRadius, 'mortared', MomentumTransfer, HitLocation);	
	start = Location + 10 * HitNormal;

	if ( (Role == ROLE_Authority) && (FRand() < 0.5) )
		MakeNoise(1.0);

        Spawn(class'enhancedrespawn',,,HitLocation+HitNormal*9);
        Spawn(class'BallExplosion',,,HitLocation+HitNormal*9);

	Destroy();
}

Begin:

	Sleep(sleeptime);
	Explode(Location, Vect(0,0,0));
}

defaultproperties
{
     DrawScale=0.500000
     BlastRadius=100
     ownerteamprojectile=0
     sleeptime=0.030000
     speed=1000.000000
     MaxSpeed=1000.000000
     bNetTemporary=False
     CollisionRadius=0.000000
     CollisionHeight=0.000000
     bBlockActors=False
     bBlockPlayers=False
     bBounce=True
}
