class MM_MeleeFirstProjectile_R expands MM_MeleeFirstProjectile;

auto state Flying
{

simulated function ProcessTouch (Actor Other, Vector HitLocation)
{


	if (Other != instigator)

	{
		if ( Role == ROLE_Authority )
       {
			Other.TakeDamage(Damage, instigator,HitLocation,
					15000.0 * Normal(velocity), 'burned');
		Explode(HitLocation, Vect(0,0,0));
       }
	}

}

simulated function Explode(vector HitLocation, vector HitNormal)
{
    local vector start;

	HurtRadius(damage, BlastRadius, 'mortared', MomentumTransfer, HitLocation);	
	start = Location + 10 * HitNormal;

	if ( (Role == ROLE_Authority) && (FRand() < 0.5) )
		MakeNoise(1.0);

        Spawn(class'RedEnhancedRespawn',,,HitLocation+HitNormal*9);
        Spawn(class'MMRedBallExplosion',,,HitLocation+HitNormal*9);

	Destroy();
}

Begin:

	Sleep(sleeptime);
	Explode(Location, Vect(0,0,0));
}

defaultproperties
{
     Sprite=FireTexture'FireEffectRed'
     Texture=FireTexture'FireEffectRed'
     Skin=FireTexture'FireEffectRed'
     MultiSkins(0)=FireTexture'FireEffectRed'
     MultiSkins(1)=FireTexture'FireEffectRed'
     MultiSkins(2)=FireTexture'FireEffectRed'
     MultiSkins(3)=FireTexture'FireEffectRed'
     MultiSkins(4)=FireTexture'FireEffectRed'
     MultiSkins(5)=FireTexture'FireEffectRed'
     MultiSkins(6)=FireTexture'FireEffectRed'
     MultiSkins(7)=FireTexture'FireEffectRed'
     SpriteAnim(0)=FireTexture'FireEffectRed'
     SpriteAnim(1)=FireTexture'FireEffectRed'
     SpriteAnim(2)=FireTexture'FireEffectRed'
     SpriteAnim(3)=FireTexture'FireEffectRed'
     SpriteAnim(4)=FireTexture'FireEffectRed'
     SpriteAnim(5)=FireTexture'FireEffectRed'
}
