class MM_NaliSpiritPickup expands MM_MonsterTool;

event float BotDesireability( pawn Bot )
{
	local inventory Inv;

	for ( Inv=Bot.inventory; Inv!=None; Inv=Inv.inventory )
		if ( Inv.IsA('MM_NaliSpiritPickup') )
			return -1;

	return Super.BotDesireability(Bot);
}

function beginPlay()
{
		loopanim('levitate',0.4);
		animframe = FRand();		
}	

function BeginState()
	{
		bActive = true;
SetTimer(5.0, true);

}
function Timer()
{
    if (pawn(owner).health<(pawn(owner).default.health))
	pawn(owner).style = STY_translucent;
	if (pawn(owner).health<0) Destroy();
}

function ArmorImpactEffect(vector HitLocation)
{ 
	if ( Owner.IsA('PlayerPawn') )
	{
		PlayerPawn(Owner).ClientFlash(-0.05,vect(400,400,400));
		PlayerPawn(Owner).PlaySound(DeActivateSound, SLOT_None, 2.7*PlayerPawn(Owner).SoundDampening);
	}

}

defaultproperties
{
     PickupMessage="You picked up the Nali Spirit Tool."
     ItemName="Nali Spirit Tool"
     PlayerViewMesh=LodMesh'UnrealShare.Nali1'
     PlayerViewScale=0.600000
     PickupViewMesh=LodMesh'UnrealShare.Nali1'
     PickupViewScale=0.600000
     ThirdPersonScale=0.600000
     AnimSequence=levitate
     Texture=None
     Mesh=LodMesh'UnrealShare.Nali1'
     DrawScale=0.600000
     ScaleGlow=3.000000
}
