//=============================================================================
// MMSpawnerProjectile.
//=============================================================================
class MM_SpawnerProjectile expands Projectile;








var() int BlastRadius;
var() texture SpriteAnim[6];
var int i;
var() bool corrupted;			//Rakiayn: Added this line//
var() int ownerteamprojectile;  //Rakiayn: Added this line//
var() float sleeptime;          //Rakiayn: the amount of time before the projectile explodes//

var() texture Blueprojectileskin;
var() texture Redprojectileskin;
var() texture Goldprojectileskin;
var() texture Greenprojectileskin;









simulated function Timer()
{
	Texture = SpriteAnim[i];
	i++;
	if (i>=6) i=0;
}

function SetUp()
{
	if ( ScriptedPawn(Instigator) != None )
		Speed = ScriptedPawn(Instigator).ProjectileSpeed;
	Velocity = Vector(Rotation) * speed;
	MakeNoise ( 1.0 );
	PlayOwnedSound(class'MM_SpawnerProjectile'.Default.SpawnSound, SLOT_None,4.2);

}

simulated function PostBeginPlay()
{
	SetUp();


	if ( Level.NetMode != NM_DedicatedServer )
	{
		Texture = SpriteAnim[0];
		i=1;
		SetTimer(5.0,True);
	}
	Super.PostBeginPlay();

}



auto state Flying
{




simulated function ProcessTouch (Actor Other, Vector HitLocation)
{


	if (Other != instigator)

	{
		if ( Role == ROLE_Authority )
       {
			Other.TakeDamage(Damage, instigator,HitLocation,
					15000.0 * Normal(velocity), 'burned');
		Explode(HitLocation, Vect(0,0,0));
       }
	}

}

function Explode(vector HitLocation, vector HitNormal)
{
	local MM_SpawnerProjectileB s;                                     ///rakiayn: the projectileb type is defined here///
                                                                      ///////////////////////////////////////////////////
    local vector start;
	
HurtRadius(damage, BlastRadius, 'mortared', MomentumTransfer, HitLocation);	
	start = Location + 10 * HitNormal;

	if ( (Role == ROLE_Authority) && (FRand() < 0.5) )
		MakeNoise(1.0); //FIXME - set appropriate loudness
                                                                      


                                                                      ///////////////////////////////////////////////////
s = Spawn(class'MM_SpawnerProjectileB',,,HitLocation+HitNormal*9);     ///rakiayn: the projectileb type is defined here///

if (s != None)
{

if (self.ownerteamprojectile == 0)
{
if ( !corrupted )
{
	Spawn(class'RedMonsterSpawnEffect',,,HitLocation+HitNormal*9);
	Spawn(class'MMredballExplosion',,,HitLocation+HitNormal*9);
	s.instigator = self.instigator;
	s.ownerteamprojectile = self.ownerteamprojectile;
}
else
{
	Spawn(class'enhancedrespawn',,,HitLocation+HitNormal*9);
	Spawn(class'BallExplosion',,,HitLocation+HitNormal*9);
	//s.instigator = self.instigator;//
	s.ownerteamprojectile = 2;
}
}

if (self.ownerteamprojectile == 1)
{
if ( !corrupted )
{
	Spawn(class'BlueMonsterSpawnEffect',,,HitLocation+HitNormal*9);
	Spawn(class'MMblueballExplosion',,,HitLocation+HitNormal*9);
	s.instigator = self.instigator;
	s.ownerteamprojectile = self.ownerteamprojectile;
	self.instigator = none;
}
else
{
	Spawn(class'enhancedrespawn',,,HitLocation+HitNormal*9);
	Spawn(class'BallExplosion',,,HitLocation+HitNormal*9);
	//s.instigator = self.instigator;//
	s.ownerteamprojectile = 2;
}
}

if (self.ownerteamprojectile == 2)
{
if ( !corrupted )
{
	Spawn(class'GreenMonsterSpawnEffect',,,HitLocation+HitNormal*9);
	Spawn(class'MMGreenballExplosion',,,HitLocation+HitNormal*9);
	s.instigator = self.instigator;
	s.ownerteamprojectile = self.ownerteamprojectile;
}
else
{
	Spawn(class'enhancedrespawn',,,HitLocation+HitNormal*9);
	Spawn(class'BallExplosion',,,HitLocation+HitNormal*9);
	//s.instigator = self.instigator;//
	s.ownerteamprojectile = 2;
}
}

if (self.ownerteamprojectile == 3)
{
if ( !corrupted )
{
	Spawn(class'GoldMonsterSpawnEffect',,,HitLocation+HitNormal*9);
	Spawn(class'MMGoldballExplosion',,,HitLocation+HitNormal*9);
	s.instigator = self.instigator;
	s.ownerteamprojectile = self.ownerteamprojectile;
}
else
{
	Spawn(class'enhancedrespawn',,,HitLocation+HitNormal*9);
	Spawn(class'BallExplosion',,,HitLocation+HitNormal*9);
	//s.instigator = self.instigator;// 
	s.ownerteamprojectile = 2;
}
}
	//s.RemoteRole = ROLE_None;//
	Destroy();
}
}

Begin:

if (self.ownerteamprojectile == 0)
{
SpriteAnim[0]=redprojectileskin;	
SpriteAnim[1]=redprojectileskin;  //1pb//
SpriteAnim[2]=redprojectileskin;
SpriteAnim[3]=redprojectileskin;	
SpriteAnim[4]=redprojectileskin;
SpriteAnim[5]=redprojectileskin;
Skin=redprojectileskin;
texture=redprojectileskin;
}
if (self.ownerteamprojectile == 1)
{
SpriteAnim[0]=Blueprojectileskin;
SpriteAnim[1]=Blueprojectileskin; // 1u//
SpriteAnim[2]=Blueprojectileskin;
SpriteAnim[3]=Blueprojectileskin;      
SpriteAnim[4]=Blueprojectileskin;
SpriteAnim[5]=Blueprojectileskin;
Skin=Blueprojectileskin;
texture=Blueprojectileskin;	
}

if (self.ownerteamprojectile == 2)
{
SpriteAnim[0]=greenprojectileskin;	// 1a//
SpriteAnim[1]=greenprojectileskin;
SpriteAnim[2]=greenprojectileskin;
SpriteAnim[3]=greenprojectileskin;	
SpriteAnim[4]=greenprojectileskin;
SpriteAnim[5]=greenprojectileskin;
Skin=greenprojectileskin;
texture=greenprojectileskin;
}
if (self.ownerteamprojectile == 3)
{
SpriteAnim[0]=goldprojectileskin;	// 1a//
SpriteAnim[1]=goldprojectileskin;
SpriteAnim[2]=goldprojectileskin;
SpriteAnim[3]=goldprojectileskin;	
SpriteAnim[4]=goldprojectileskin;
SpriteAnim[5]=goldprojectileskin;
Skin=goldprojectileskin;
texture=goldprojectileskin;
}




	Sleep(sleeptime);
	Explode(Location, Vect(0,0,0));



}











function BlowUp(vector HitLocation)
	{
		HurtRadius(Damage,2200.1000, MyDamageType, MomentumTransfer, HitLocation );
		MakeNoise(1.0);
	}

//==============
// Touching
simulated singular function Touch(Actor Other)
{
	local actor HitActor;
	local vector HitLocation, HitNormal, TestLocation;
	
	if ( Other.IsA('BlockAll') )
	{
		HitWall( Normal(Location - Other.Location), Other);
		return;
	}
	if ( Other.IsA('blockspawnprojectiles') )
	{
		HitWall( Normal(Location - Other.Location), Other);
		return;
	}
	if ( Other.bProjTarget || (Other.bBlockActors && Other.bBlockPlayers) )
	{
		//get exact hitlocation
	 	HitActor = Trace(HitLocation, HitNormal, Location, OldLocation, true);
		if (HitActor == Other)
		{
			if ( Other.bIsPawn 
				&& !Pawn(Other).AdjustHitLocation(HitLocation, Velocity) )
					return;
			ProcessTouch(Other, HitLocation); 
		}
		else 
			ProcessTouch(Other, Other.Location + Other.CollisionRadius * Normal(Location - Other.Location));
	}
}

defaultproperties
{
     BlastRadius=800
     SpriteAnim(0)=FireTexture'UnrealShare.Effect1.FireEffect1a'
     SpriteAnim(1)=FireTexture'UnrealShare.Effect1.FireEffect1a'
     SpriteAnim(2)=FireTexture'UnrealShare.Effect1.FireEffect1a'
     SpriteAnim(3)=FireTexture'UnrealShare.Effect1.FireEffect1a'
     SpriteAnim(4)=FireTexture'UnrealShare.Effect1.FireEffect1a'
     SpriteAnim(5)=FireTexture'UnrealShare.Effect1.FireEffect1a'
     ownerteamprojectile=255
     sleeptime=3.000000
     Blueprojectileskin=FireTexture'UnrealShare.Effect1.FireEffect1u'
     Redprojectileskin=FireTexture'FireEffectRed'
     goldprojectileskin=FireTexture'UnrealShare.Effect1.FireEffect1e'
     Greenprojectileskin=FireTexture'UnrealShare.Effect1.FireEffect1a'
     speed=1500.000000
     MomentumTransfer=150000
     Physics=PHYS_Falling
     RemoteRole=ROLE_SimulatedProxy
     LifeSpan=3.500000
     DrawType=DT_Sprite
     Style=STY_Translucent
     Texture=FireTexture'UnrealShare.Effect1.FireEffect1a'
     DrawScale=0.500000
     bUnlit=True
     CollisionRadius=1.000000
     CollisionHeight=1.000000
     bBlockActors=True
     bBlockPlayers=True
}
