//=============================================================================
// WarLordSpawnProjectileB.
//=============================================================================
class MM_WarLordSpawnProjectileB expands MM_SpawnerProjectileB;

auto state Flying
{


simulated function ProcessTouch (Actor Other, Vector HitLocation)
{
	if (Other != instigator)
	{
		if ( Role == ROLE_Authority )
			Other.TakeDamage(Damage, instigator,HitLocation,
					15000.0 * Normal(velocity), 'burned');
		Explode(HitLocation, Vect(0,0,0));
	}
}

function Explode(vector HitLocation, vector HitNormal)
{
local mm_warlord s; 
local inventory w; 
local inventory v; 
local float Selection;

local vector X,Y,Z, projStart; //test//

	if ( (Role == ROLE_Authority) && (FRand() < 0.5) )
		MakeNoise(1.0); //FIXME - set appropriate loudness

w = instigator.FindInventoryType(class'MM_GoldTitanTool');
	if ( w == None )
    {
    s =  Spawn(class'mm_warlord',,,HitLocation+HitNormal*9);
    }
 w = instigator.FindInventoryType(class'MM_GoldTitanTool');
   	if ( w != None )
{
if (instigator.playerreplicationinfo.score <= 1)
	{
	s =  Spawn(class'mm_warlord',,,HitLocation+HitNormal*9);  	       
	}
if (instigator.playerreplicationinfo.score >= 1)
    {	       
	s =  Spawn(class'mm_warlordbig',,,HitLocation+HitNormal*9);
	self.drawscale =  (self.drawscale*1.25);
	s.drawscale =  (s.drawscale*1.25);
	s.health = (s.health*1.25);
	self.drawscale =  (self.drawscale*1.25);
	s.jumpz =  (s.jumpz*1.25);
	s.maxstepheight =  (s.maxstepheight*1.25);
	s.buoyancy =  (s.buoyancy*1.75); 	       
	}
}

/////////////////////////

 w = instigator.FindInventoryType(class'MM_BronzeSpeedTool');
   	if ( w != None )  
{


 w = instigator.FindInventoryType(class'MM_SilverSpeedTool');
   	if ( w != None )  
  {
s.GroundSpeed = 1.6*s.Default.Groundspeed;
s.airSpeed = 1.6*s.Default.airspeed;
s.waterSpeed = 1.6*s.Default.waterspeed;
  }
 w = instigator.FindInventoryType(class'MM_SilverSpeedTool');
   	if ( w == None )  
  {
s.GroundSpeed = 1.3*s.Default.Groundspeed;
s.airSpeed = 1.3*s.Default.airspeed;
s.waterSpeed = 1.3*s.Default.waterspeed;
  }

}



/////////////////////////
//Rakiayn: MM_Silverspeedtool/////
/////////////////////////

 w = instigator.FindInventoryType(class'MM_SilverSpeedTool');
   	if ( w != None )  
{


 w = instigator.FindInventoryType(class'MM_BronzeSpeedTool');
   	if ( w != None )  
  {
s.GroundSpeed = 1.7*s.Default.Groundspeed;
s.airSpeed = 1.7*s.Default.airspeed;
s.waterSpeed = 1.7*s.Default.waterspeed;
  }
 w = instigator.FindInventoryType(class'MM_BronzeSpeedTool');
   	if ( w == None )  
  {
s.GroundSpeed = 1.5*s.Default.Groundspeed;
s.airSpeed = 1.5*s.Default.airspeed;
s.waterSpeed = 1.5*s.Default.waterspeed;
  }

}

//////////////////////////////////////////////////
//////////////////////////////////////////////////   
 	       
   
/////////////////////
//Rakiayn: Zombietool
/////////////////////

Selection = FRand();

v = instigator.FindInventoryType(class'MM_GoldUnholyTool');
	if ( v != None ) 
  {

v = instigator.FindInventoryType(class'MM_SilverImprovementTool');
	if ( v == None ) 
  {

if ( Selection < 0.6 )

     {
 s.zombiechance = ((0.002*((instigator.playerreplicationinfo.score)*(instigator.playerreplicationinfo.score)+0.001))/(((instigator.playerreplicationinfo.score)+4)/0.1 )+0.05);//
s.fatness = 0.6*s.default.fatness;
     }
else
     {
s.zombiechance=0.4;
s.fatness = 0.6*s.default.fatness;
     }
  }
//////
//////
v = instigator.FindInventoryType(class'MM_SilverImprovementTool');
	if ( v != None ) 
  {

if ( Selection < 0.4 )

     {
 s.zombiechance = ((0.002*((instigator.playerreplicationinfo.score)*(instigator.playerreplicationinfo.score)+0.001))/(((instigator.playerreplicationinfo.score)+4)/0.1 )+0.05);//
s.zombieskin = s.meanzombieskin;
s.fatness = 0.4*s.default.fatness;
     }
else
     {
s.zombiechance=0.8;
s.zombieskin = s.meanzombieskin;
s.fatness = 0.4*s.default.fatness;
     }
  }

}



/////////////////////
//Rakiayn: Zombietool
/////////////////////


if (self.ownerteamprojectile == 0)
{

    Spawn(class'RedMonsterSpawnEffect',,,HitLocation+HitNormal*9);
 

    PlaySound(redspawnSound);
    s.playerreplicationinfo.team = self.ownerteamprojectile;
    s.instigator = self.instigator;  //Rakiayn: this line is part of the connection between the monster and the player who summoned it//
	//s.RemoteRole = ROLE_None;//
    s.dropwhenkilled = none;   // monster drops ammo//	
//////////////////////////////
    s.skin = s.redteamskin; 
    s.multiskins[0] = s.multiskinsredteam[0];
    s.multiskins[1] = s.multiskinsredteam[1];
    s.multiskins[2] = s.multiskinsredteam[2];
    s.multiskins[3] = s.multiskinsredteam[3];
    s.multiskins[4] = s.multiskinsredteam[4];
    s.multiskins[5] = s.multiskinsredteam[5];
    s.multiskins[6] = s.multiskinsredteam[6];
    s.multiskins[7] = s.multiskinsredteam[7];
//////////////////////////////
    Destroy();

}
if (self.ownerteamprojectile == 1)
{
	 
    Spawn(class'BlueMonsterSpawnEffect',,,HitLocation+HitNormal*9);

    PlaySound(bluespawnSound);
    s.playerreplicationinfo.team = self.ownerteamprojectile;
    s.instigator = self.instigator;  //Rakiayn: this line is part of the connection between the monster and the player who summoned it//
	//s.RemoteRole = ROLE_None;//
    s.dropwhenkilled = none;   // monster drops ammo//	
//////////////////////////////
    s.skin = s.blueteamskin; 
    s.multiskins[0] = s.multiskinsblueteam[0];
    s.multiskins[1] = s.multiskinsblueteam[1];
    s.multiskins[2] = s.multiskinsblueteam[2];
    s.multiskins[3] = s.multiskinsblueteam[3];
    s.multiskins[4] = s.multiskinsblueteam[4];
    s.multiskins[5] = s.multiskinsblueteam[5];
    s.multiskins[6] = s.multiskinsblueteam[6];
    s.multiskins[7] = s.multiskinsblueteam[7];
//////////////////////////////
    Destroy();
}
if (self.ownerteamprojectile == 2)
{
	  
    Spawn(class'GreenMonsterSpawnEffect',,,HitLocation+HitNormal*9);

    PlaySound(greenspawnSound);
    s.playerreplicationinfo.team = self.ownerteamprojectile;
    s.instigator = self.instigator;  //Rakiayn: this line is part of the connection between the monster and the player who summoned it//
	//s.RemoteRole = ROLE_None;//
    s.dropwhenkilled = none;   // monster drops ammo//	
    Destroy();

}
if (self.ownerteamprojectile == 3)
{

    spawn(class'GoldMonsterSpawnEffect',,,HitLocation+HitNormal*9);

    PlaySound(greenspawnSound);
    s.playerreplicationinfo.team = self.ownerteamprojectile;
    s.instigator = self.instigator;  //Rakiayn: this line is part of the connection between the monster and the player who summoned it//
	//s.RemoteRole = ROLE_None;//
    s.dropwhenkilled = none;   // monster drops ammo//	
    Destroy();

}
Destroy();


}
Begin:

 




if (self.ownerteamprojectile == 0)
{
multiskins[0]=team0projectileskin;	
multiskins[1]=team0projectileskin;
multiskins[2]=team0projectileskin;
multiskins[3]=team0projectileskin;	
multiskins[4]=team0projectileskin;
multiskins[5]=team0projectileskin;
multiskins[6]=team0projectileskin;
multiskins[7]=team0projectileskin;


Skin=team0projectileskin;
texture=team0projectileskin;
}
if (self.ownerteamprojectile == 1)
{
multiskins[0]=team1projectileskin;
multiskins[1]=team1projectileskin;
multiskins[2]=team1projectileskin;
multiskins[3]=team1projectileskin;
multiskins[4]=team1projectileskin;
multiskins[5]=team1projectileskin;
multiskins[6]=team1projectileskin;
multiskins[7]=team1projectileskin;


Skin=team1projectileskin;
texture=team1projectileskin;
}

if (self.ownerteamprojectile == 2)
{
multiskins[0]=team2projectileskin;
multiskins[1]=team2projectileskin;
multiskins[2]=team2projectileskin;
multiskins[3]=team2projectileskin;
multiskins[4]=team2projectileskin;
multiskins[5]=team2projectileskin;
multiskins[6]=team2projectileskin;
multiskins[7]=team2projectileskin;

Skin=team2projectileskin;
texture=team2projectileskin;
}
if (self.ownerteamprojectile == 3)
{
multiskins[0]=team3projectileskin;
multiskins[1]=team3projectileskin;
multiskins[2]=team3projectileskin;
multiskins[3]=team3projectileskin;
multiskins[4]=team3projectileskin;
multiskins[5]=team3projectileskin;
multiskins[6]=team3projectileskin;
multiskins[7]=team3projectileskin;

Skin=team3projectileskin;
texture=team3projectileskin;
}




	Sleep(sleeptime);
	Explode(Location, Vect(0,0,0));

}

defaultproperties
{
     Skin=FireTexture'UnrealShare.Effect7.MyTex16'
     Mesh=LodMesh'UnrealI.WarlordM'
     DrawScale=1.000000
     CollisionRadius=65.000000
     CollisionHeight=97.000000
}
