class RedMonsterSpawnEffect expands UTTeleportEffect;

var UTTeleEffectRed T1, T2;

simulated event PostNetBeginPlay()
{
	super.PostNetBeginPlay();
	WetTexture'utflare_red1'.Palette = Texture'Red'.Palette;
	WetTexture'utflare_red2'.Palette = Texture'Red'.Palette;
	WetTexture'utflare_red3'.Palette = Texture'Red'.Palette;
	WetTexture'utflare_red4'.Palette = Texture'Red'.Palette;
	WetTexture'utflare_red5'.Palette = Texture'Red'.Palette;
	WetTexture'utflare_red6'.Palette = Texture'Red'.Palette;
	WetTexture'utflare_red7'.Palette = Texture'Red'.Palette;
	WetTexture'utflare_red8'.Palette = Texture'Red'.Palette;
}

function PostBeginPlay()
{
	WetTexture'utflare_red1'.Palette = Texture'Red'.Palette;
	WetTexture'utflare_red2'.Palette = Texture'Red'.Palette;
	WetTexture'utflare_red3'.Palette = Texture'Red'.Palette;
	WetTexture'utflare_red4'.Palette = Texture'Red'.Palette;
	WetTexture'utflare_red5'.Palette = Texture'Red'.Palette;
	WetTexture'utflare_red6'.Palette = Texture'Red'.Palette;
	WetTexture'utflare_red7'.Palette = Texture'Red'.Palette;
	WetTexture'utflare_red8'.Palette = Texture'Red'.Palette;
}

auto state Explode
{
	simulated function Tick(float DeltaTime)
	{
		local rotator newrot;

		if ( !Level.bHighDetailMode )
		{
			bOwnerNoSee = true;
			Disable('Tick');
			return;
		}

		if ( Level.NetMode == NM_DedicatedServer )
		{
			Disable('Tick');
			return;
		}

		ScaleGlow = (Lifespan/Default.Lifespan);	
		LightBrightness = ScaleGlow*210.0;

		if ( !Level.bHighDetailMode )
		{
			LightRadius = 6;
			return;
		}

		if ( !bSpawnEffects )
		{
			bSpawnEffects = true;
			T1 = spawn(class'UTTeleEffectRed');
			newrot = Rotation;
			newRot.Yaw = Rand(65535);
			T2 = spawn(class'UTTeleEffectRed',,,location - vect(0,0,10), newRot);
		}
		else
		{
			if ( T1 != None )
				T1.ScaleGlow = ScaleGlow;
			if ( T2 != None )
				T2.ScaleGlow = ScaleGlow;
		}
	}
}

defaultproperties
{
     Texture=Texture'utflare_red1'
     Skin=Texture'UnrealShare.DispExpl.DseO_A01'
     LightHue=0
     LightSaturation=0
     LODBias=20
     MultiSkins(0)=Texture'utflare_red1'
     MultiSkins(1)=Texture'utflare_red2'
     MultiSkins(2)=Texture'utflare_red3'
     MultiSkins(3)=Texture'utflare_red4'
     MultiSkins(4)=Texture'utflare_red5'
     MultiSkins(5)=Texture'utflare_red6'
     MultiSkins(6)=Texture'utflare_red7'
     MultiSkins(7)=Texture'utflare_red8'
}
