class GoldMonsterSpawnEffect expands UTTeleportEffect;

var UTTeleEffectGold T1, T2;

simulated event PostNetBeginPlay()
{
	super.PostNetBeginPlay();
	WetTexture'utflare_gold1'.Palette = Texture'Gold'.Palette;
	WetTexture'utflare_gold2'.Palette = Texture'Gold'.Palette;
	WetTexture'utflare_gold3'.Palette = Texture'Gold'.Palette;
	WetTexture'utflare_gold4'.Palette = Texture'Gold'.Palette;
	WetTexture'utflare_gold5'.Palette = Texture'Gold'.Palette;
	WetTexture'utflare_gold6'.Palette = Texture'Gold'.Palette;
	WetTexture'utflare_gold7'.Palette = Texture'Gold'.Palette;
	WetTexture'utflare_gold8'.Palette = Texture'Gold'.Palette;
}

function PostBeginPlay()
{
	WetTexture'utflare_gold1'.Palette = Texture'Gold'.Palette;
	WetTexture'utflare_gold2'.Palette = Texture'Gold'.Palette;
	WetTexture'utflare_gold3'.Palette = Texture'Gold'.Palette;
	WetTexture'utflare_gold4'.Palette = Texture'Gold'.Palette;
	WetTexture'utflare_gold5'.Palette = Texture'Gold'.Palette;
	WetTexture'utflare_gold6'.Palette = Texture'Gold'.Palette;
	WetTexture'utflare_gold7'.Palette = Texture'Gold'.Palette;
	WetTexture'utflare_gold8'.Palette = Texture'Gold'.Palette;
}

auto state Explode
{
	simulated function Tick(float DeltaTime)
	{
		local rotator newrot;

		if ( !Level.bHighDetailMode )
		{
			bOwnerNoSee = true;
			Disable('Tick');
			return;
		}

		if ( Level.NetMode == NM_DedicatedServer )
		{
			Disable('Tick');
			return;
		}

		ScaleGlow = (Lifespan/Default.Lifespan);	
		LightBrightness = ScaleGlow*210.0;

		if ( !Level.bHighDetailMode )
		{
			LightRadius = 6;
			return;
		}

		if ( !bSpawnEffects )
		{
			bSpawnEffects = true;
			T1 = spawn(class'UTTeleEffectGold');
			newrot = Rotation;
			newRot.Yaw = Rand(65535);
			T2 = spawn(class'UTTeleEffectGold',,,location - vect(0,0,10), newRot);
		}
		else
		{
			if ( T1 != None )
				T1.ScaleGlow = ScaleGlow;
			if ( T2 != None )
				T2.ScaleGlow = ScaleGlow;
		}
	}
}

defaultproperties
{
     Texture=Texture'utflare_gold1'
     Skin=Texture'UnrealShare.DispExpl.dseY_A01'
     LightHue=30
     LightSaturation=0
     LODBias=20
     MultiSkins(0)=Texture'utflare_gold1'
     MultiSkins(1)=Texture'utflare_gold2'
     MultiSkins(2)=Texture'utflare_gold3'
     MultiSkins(3)=Texture'utflare_gold4'
     MultiSkins(4)=Texture'utflare_gold5'
     MultiSkins(5)=Texture'utflare_gold6'
     MultiSkins(6)=Texture'utflare_gold7'
     MultiSkins(7)=Texture'utflare_gold8'
}
