class MMBaseKilledMsg extends CriticalEventPlus;

#exec AUDIO IMPORT FILE="Sounds\DieBeep.WAV" GROUP="Sounds"

var() color col;

static function color GetColor(
  optional int Switch,
  optional PlayerReplicationInfo RelatedPRI_1, 
  optional PlayerReplicationInfo RelatedPRI_2)
{
    return Default.col;
}

static function string GetString(
  optional int Switch,
  optional PlayerReplicationInfo RelatedPRI_1, 
  optional PlayerReplicationInfo RelatedPRI_2,
  optional Object OptionalObject)
{
    return "YOUR BASE QUEEN WAS KILLED!";
}

static simulated function ClientReceive( 
  PlayerPawn P,
  optional int Switch,
  optional PlayerReplicationInfo RelatedPRI_1, 
  optional PlayerReplicationInfo RelatedPRI_2,
  optional Object OptionalObject)
{
	Super.ClientReceive(P, Switch, RelatedPRI_1, RelatedPRI_2, OptionalObject);
	P.PlaySound(sound'DieBeep');
}

defaultproperties
{
     col=(R=255)
     bBeep=False
}
