class MM_BehemothSpawnProjectile expands MM_SpawnerProjectile;

auto state Flying
{

simulated function ProcessTouch (Actor Other, Vector HitLocation)
{
	if (Other != instigator)
	{
		if ( Role == ROLE_Authority )
			Other.TakeDamage(Damage, instigator,HitLocation,
					15000.0 * Normal(velocity), 'burned');
		Explode(HitLocation, Vect(0,0,0));
	}
}

function Explode(vector HitLocation, vector HitNormal)
{
	local MM_behemothspawnProjectileB s;
	local vector start;

	HurtRadius(damage, BlastRadius, 'mortared', MomentumTransfer, HitLocation);	
	start = Location + 10 * HitNormal;
	if ( (Role == ROLE_Authority) && (FRand() < 0.5) )
	MakeNoise(1.0);
	s = Spawn(class'MM_behemothspawnProjectileB',,,HitLocation+HitNormal*9);

if (s != None)
{

if (self.ownerteamprojectile == 0)
{
if ( !corrupted )
{
	Spawn(class'RedMonsterSpawnEffect',,,HitLocation+HitNormal*9);
	Spawn(class'MMredballExplosion',,,HitLocation+HitNormal*9);
	s.instigator = self.instigator;
	s.ownerteamprojectile = self.ownerteamprojectile;
}
else
{
	Spawn(class'enhancedrespawn',,,HitLocation+HitNormal*9);
	Spawn(class'BallExplosion',,,HitLocation+HitNormal*9);
	//s.instigator = self.instigator;//
	s.ownerteamprojectile = 2;
}
}

if (self.ownerteamprojectile == 1)
{
if ( !corrupted )
{
	Spawn(class'BlueMonsterSpawnEffect',,,HitLocation+HitNormal*9);
	Spawn(class'MMblueballExplosion',,,HitLocation+HitNormal*9);
	s.instigator = self.instigator;
	s.ownerteamprojectile = self.ownerteamprojectile;
	self.instigator = none;
}
else
{
	Spawn(class'enhancedrespawn',,,HitLocation+HitNormal*9);
	Spawn(class'BallExplosion',,,HitLocation+HitNormal*9);
	//s.instigator = self.instigator;//
	s.ownerteamprojectile = 2;
}
}

if (self.ownerteamprojectile == 2)
{
if ( !corrupted )
{
	Spawn(class'GreenMonsterSpawnEffect',,,HitLocation+HitNormal*9);
	Spawn(class'MMGreenballExplosion',,,HitLocation+HitNormal*9);
	s.instigator = self.instigator;
	s.ownerteamprojectile = self.ownerteamprojectile;
}
else
{
	Spawn(class'enhancedrespawn',,,HitLocation+HitNormal*9);
	Spawn(class'BallExplosion',,,HitLocation+HitNormal*9);
	//s.instigator = self.instigator;//
	s.ownerteamprojectile = 2;
}
}

if (self.ownerteamprojectile == 3)
{
if ( !corrupted )
{
	Spawn(class'GoldMonsterSpawnEffect',,,HitLocation+HitNormal*9);
	Spawn(class'MMGoldballExplosion',,,HitLocation+HitNormal*9);
	s.instigator = self.instigator;
	s.ownerteamprojectile = self.ownerteamprojectile;
}
else
{
	Spawn(class'enhancedrespawn',,,HitLocation+HitNormal*9);
	Spawn(class'BallExplosion',,,HitLocation+HitNormal*9);
	//s.instigator = self.instigator;// 
	s.ownerteamprojectile = 2;
}
}
	//s.RemoteRole = ROLE_None;//
	Destroy();
}
}

Begin:

if (self.ownerteamprojectile == 0)
{
SpriteAnim[0]=redprojectileskin;
SpriteAnim[1]=redprojectileskin;
SpriteAnim[2]=redprojectileskin;
SpriteAnim[3]=redprojectileskin;
SpriteAnim[4]=redprojectileskin;
SpriteAnim[5]=redprojectileskin;
Skin=redprojectileskin;
texture=redprojectileskin;
}
if (self.ownerteamprojectile == 1)
{
SpriteAnim[0]=Blueprojectileskin;
SpriteAnim[1]=Blueprojectileskin;
SpriteAnim[2]=Blueprojectileskin;
SpriteAnim[3]=Blueprojectileskin;      
SpriteAnim[4]=Blueprojectileskin;
SpriteAnim[5]=Blueprojectileskin;
Skin=Blueprojectileskin;
texture=Blueprojectileskin;	
}

if (self.ownerteamprojectile == 2)
{
SpriteAnim[0]=greenprojectileskin;
SpriteAnim[1]=greenprojectileskin;
SpriteAnim[2]=greenprojectileskin;
SpriteAnim[3]=greenprojectileskin;	
SpriteAnim[4]=greenprojectileskin;
SpriteAnim[5]=greenprojectileskin;
Skin=greenprojectileskin;
texture=greenprojectileskin;
}
if (self.ownerteamprojectile == 3)
{
SpriteAnim[0]=goldprojectileskin;
SpriteAnim[1]=goldprojectileskin;
SpriteAnim[2]=goldprojectileskin;
SpriteAnim[3]=goldprojectileskin;	
SpriteAnim[4]=goldprojectileskin;
SpriteAnim[5]=goldprojectileskin;
Skin=goldprojectileskin;
texture=goldprojectileskin;
}
	Sleep(sleeptime);
	Explode(Location, Vect(0,0,0));
}

defaultproperties
{
     BlastRadius=450
     MomentumTransfer=200000
     bNetTemporary=False
     SoundRadius=64
     SoundVolume=96
     bBlockPlayers=False
}
