//=============================================================================
// GiveAmmoProjectile.
//=============================================================================
class MM_GiveAmmoProjectile expands MM_SpawnerProjectile;


var() texture SpriteAnim[6];
var int i;



function SetUp()
{
	if ( ScriptedPawn(Instigator) != None )
		Speed = ScriptedPawn(Instigator).ProjectileSpeed;
	Velocity = Vector(Rotation) * speed;
	MakeNoise ( 1.0 );
	
}

	simulated function BeginState()
	{

		SetTimer(0.2, false);
		SetUp();

		if ( Level.NetMode != NM_DedicatedServer )
		{
			LoopAnim('All',1.0);
			if ( Level.NetMode == NM_Standalone )
				SoundPitch = 200 + 50 * FRand();
		}			
	}




///////////
//////////


simulated function Timer()
{
	Texture = SpriteAnim[i];
	i++;
	if (i>=6) i=0;
}





simulated function PostBeginPlay()
{
	SetUp();
	if ( Level.NetMode != NM_DedicatedServer )
	{
		Texture = SpriteAnim[0];
		i=1;
		SetTimer(0.15,True);
	}
	Super.PostBeginPlay();
}

auto state Flying
{


simulated function ProcessTouch (Actor Other, Vector HitLocation)
{
	if (Other != instigator)
	{
		if ( Role == ROLE_Authority )
			Other.TakeDamage(Damage, instigator,HitLocation,
					15000.0 * Normal(velocity), 'burned');
		Explode(HitLocation, Vect(0,0,0));
	}
}

simulated function Explode(vector HitLocation, vector HitNormal)
{
	local Giveammo G;

	if ( (Role == ROLE_Authority) && (FRand() < 0.5) )
		MakeNoise(1.0); //FIXME - set appropriate loudness

	G = Spawn(class'Giveammo',,,HitLocation+HitNormal*9);
        Spawn(class'enhancedrespawn',,,HitLocation+HitNormal*9);
     PlaySound(spawnSound);

	//g.RemoteRole = ROLE_None;//




	Destroy();



}

Begin:
	Sleep(0.1);
	Explode(Location, Vect(0,0,0));

}

defaultproperties
{
     SpriteAnim(1)=FireTexture'UnrealShare.Effect1.FireEffect1a'
     SpriteAnim(3)=FireTexture'UnrealShare.Effect1.FireEffect1a'
     SpriteAnim(4)=FireTexture'UnrealShare.Effect1.FireEffect1a'
     SpriteAnim(5)=FireTexture'UnrealShare.Effect1.FireEffect1a'
     sleeptime=0.000000
     bNetTemporary=False
}
