class MM_GoldNaliSpiritTool expands MM_GoldMonsterTool;

event float BotDesireability( pawn Bot )
{
	local inventory Inv;

	for ( Inv=Bot.inventory; Inv!=None; Inv=Inv.inventory )
		if ( Inv.IsA('MM_GoldNaliSpiritTool') )
			return -1;

	return Super.BotDesireability(Bot);
}

function beginPlay()
{
		loopanim('levitate',0.4);
		animframe = FRand();		
}	

function BeginState()
	{
		bActive = true;
SetTimer(5.0, true);

}
function Timer()
{
	if (pawn(owner).health<0) Destroy();
}

function ArmorImpactEffect(vector HitLocation)
{ 
	if ( Owner.IsA('PlayerPawn') )
	{
		PlayerPawn(Owner).ClientFlash(-0.05,vect(400,400,400));
		PlayerPawn(Owner).PlaySound(DeActivateSound, SLOT_None, 2.7*PlayerPawn(Owner).SoundDampening);
	}
}

function PickupFunction(Pawn Other)
{
	local Inventory Inv;

        inv = instigator.FindInventoryType(class'MM_Goldtitantool');
   	 
		if( inv != None )
		{
				inv.destroy();
              PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Gold' @ 'Titan' @ 'Tool'$M_DeActivated$ItemName);	
		}

        inv = instigator.FindInventoryType(class'MM_Goldunholytool');
   	 
		if( inv != None )
		{
				inv.destroy();
               PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Gold' @ 'Unholy' @ 'Tool'$M_DeActivated$ItemName);	
		}

    inv = instigator.FindInventoryType(class'MM_GoldMonsterCredittool');
   	 
		if( inv != None )
		{
				inv.destroy();
               PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Gold' @ 'Unholy' @ 'Tool'$M_DeActivated$ItemName);	
		}
        		if( inv == None )
		{
			  Pawn(Owner).ClientMessage(M_Selected$ItemName);	
		}
}

defaultproperties
{
     PickupMessage="You picked up the Gold Nali Spirit Tool."
     ItemName="Gold Nali Spirit Tool"
     PlayerViewMesh=LodMesh'UnrealShare.Nali1'
     PlayerViewScale=0.400000
     PickupViewMesh=LodMesh'UnrealShare.Nali1'
     PickupViewScale=0.400000
     AnimSequence=levitate
     Mesh=LodMesh'UnrealShare.Nali1'
     DrawScale=0.400000
     CollisionHeight=20.000000
}
