class MM_GoldUnholyTool expands MM_GoldMonsterTool;

event float BotDesireability( pawn Bot )
{
	local inventory Inv;

	for ( Inv=Bot.inventory; Inv!=None; Inv=Inv.inventory )
		if ( Inv.IsA('MM_GoldUnholyTool') )
			return -1;

	return Super.BotDesireability(Bot);
}

function BeginState()
	{
		bActive = true;
SetTimer(1.0, true);

}
function Timer()
{

pawn(owner).Fatness = 0.8*pawn(owner).default.fatness;
  
	if (pawn(owner).health<0) Destroy();
}

function ArmorImpactEffect(vector HitLocation)
{ 
	if ( Owner.IsA('PlayerPawn') )
	{
		PlayerPawn(Owner).ClientFlash(-0.05,vect(400,400,400));
		PlayerPawn(Owner).PlaySound(DeActivateSound, SLOT_None, 2.7*PlayerPawn(Owner).SoundDampening);
	}
}

function PickupFunction(Pawn Other)
{
	local Inventory Inv;

        inv = instigator.FindInventoryType(class'MM_Goldtitantool');
   	 
		if( inv != None )
		{
				inv.destroy();
              PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Gold' @ 'Titan' @ 'Tool'$M_DeActivated$ItemName);	
		}

        inv = instigator.FindInventoryType(class'MM_GoldNaliSpiritTool');
   	 
		if( inv != None )
		{
				inv.destroy();
               PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Gold' @ 'Nali' @ 'Spirit' @ 'Tool'$M_DeActivated$ItemName);	
		}
    inv = instigator.FindInventoryType(class'MM_GoldMonsterCredittool');
   	 
		if( inv != None )
		{
				inv.destroy();
               PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Gold' @ 'Unholy' @ 'Tool'$M_DeActivated$ItemName);	
		}
        		if( inv == None )
		{
			  Pawn(Owner).ClientMessage(M_Selected$ItemName);	
		}
}

defaultproperties
{
     PickupMessage="You picked up the Gold Unholy Tool."
     ItemName="Gold Unholy Tool "
     PlayerViewMesh=LodMesh'UnrealShare.CandleM'
     PlayerViewScale=1.500000
     PickupViewMesh=LodMesh'UnrealShare.CandleM'
     PickupViewScale=1.500000
     Mesh=LodMesh'UnrealShare.CandleM'
     DrawScale=1.500000
     CollisionHeight=20.000000
}
