class MM_LifePickup expands MM_MonsterTool;

event float BotDesireability( pawn Bot )
{
	local inventory Inv;

	for ( Inv=Bot.inventory; Inv!=None; Inv=Inv.inventory )
		if ( Inv.IsA('MM_LifePickup') )
			return -1;

	return Super.BotDesireability(Bot);
}

function BeginState()
	{
		bActive = true;
SetTimer(1.0, true);

}
function Timer()
{
    if (pawn(owner).health<(pawn(owner).default.health*2))
	pawn(owner).health +=1;
	if (pawn(owner).health<0) Destroy();
}

function ArmorImpactEffect(vector HitLocation)
{ 
	if ( Owner.IsA('PlayerPawn') )
	{
		PlayerPawn(Owner).ClientFlash(-0.05,vect(400,400,400));
		PlayerPawn(Owner).PlaySound(DeActivateSound, SLOT_None, 2.7*PlayerPawn(Owner).SoundDampening);
	}
}

defaultproperties
{
     bCanHaveMultipleCopies=True
     PickupMessage="You picked up the Life Tool."
     ItemName="Life Tool"
     PlayerViewMesh=LodMesh'UnrealShare.PHeartM'
     PlayerViewScale=2.000000
     PickupViewMesh=LodMesh'UnrealShare.PHeartM'
     PickupViewScale=2.000000
     Texture=None
     Mesh=LodMesh'UnrealShare.PHeartM'
     DrawScale=2.000000
     ScaleGlow=5.000000
     SoundRadius=16
     SoundPitch=48
     RotationRate=(Pitch=20000,Yaw=30000,Roll=25000)
}
