class MM_NaliRabbit extends Nali_Rabbit 
	config(MM_Pupae);

var() byte meleeteamvaluemonster;
var() byte Team;
var() config bool bHateOurOwn;
var() config bool bRespawn;
var MMMonsterStart startPoint;
var MonstermadnessMsgDelay msgDelayer;
var() config float RespawnDelay;
var() byte scorevalue;

function PreBeginPlay()
{
	local MM_Mutator dmtMutator;
	local bool bMutatorSpawned;
	local int iNameNumber;
	local string MyNewName;
	local float Selection;	

	bIsPlayer = true;
	Super.PreBeginPlay();

if (brespawn)

{
	startPoint = spawn(class'MMMonsterStart', self, , 
			Location, Rotation);
	if(startPoint == None)
	{
		Log(class$":PreBeginPlay : Couldn't spawn startPoint.");
	}
}
	bMutatorSpawned = false;
	foreach AllActors(class'MM_Mutator', dmtMutator)
	{
		bMutatorSpawned = true;
	}
	if(!bMutatorSpawned)
	{
		Log(class$":PreBeginPlay : Creating a MM_Mutator.");
		level.game.BaseMutator.AddMutator(Spawn(class'MM_Mutator'));
	}
meleeteamvaluemonster = team;

	if(Level.Game.IsA('TeamGamePlus'))
		PlayerReplicationInfo.Team = Team;
	else
		PlayerReplicationInfo.Team = 255;

	if ( Team == 0 )
	{
	}
	if ( Team == 1 )
	{
	}
	if ( Team == 3 )
	{
	}
	SetInventory();
}

function postbeginplay()
{
    local float Selection;

playerreplicationinfo.playername="Nali Rabbit";

	if ( Team == 3 )
	{
Selection = FRand();
if ( Selection < 1.0 )
	{
dropwhenkilled = (Class'MM_NaliRabbitAmmo');
}
}
}

function bool IsPlayerNameBeingUsed(String strName)
{
	local PlayerReplicationInfo otherPRI;

	ForEach AllActors(class'PlayerReplicationInfo', otherPRI)
	{
		if(otherPRI != PlayerReplicationInfo &&
			otherPRI.PlayerName ~= strName)
		{
			return true;
		}
	}

	return false;
}

function SetInventory()
{
	local Translator s;

	if ( FindInventoryType(class'Translator') != None )
		return;
	s = Spawn(class'Translator',,, Location);
	if (s != None)
	{
		s.bHeldItem = true;
		s.GiveTo( self );
	}

	if(inventory==None)
		Log(class$":SetInventory : No damn inventory!");
}

function bool SetEnemy( Pawn NewEnemy )
{
	local bool result;
	local eAttitude newAttitude, oldAttitude;
	local bool noOldEnemy;
	local float newStrength;

	if(NewEnemy.GetStateName() == 'PlayerWaiting')
	{
		return false;
	}

	if(PlayerReplicationInfo.Team != 255 &&
			PlayerReplicationInfo.Team == NewEnemy.PlayerReplicationInfo.Team)
	{
		return false;
	}

	if ( !bCanWalk && !bCanFly && !NewEnemy.FootRegion.Zone.bWaterZone )
		return false;
	if ( (NewEnemy == Self) || (NewEnemy == None) || (NewEnemy.Health <= 0) )
		return false;
	if ( (PlayerPawn(NewEnemy) == None) && 
		(ScriptedPawn(NewEnemy) == None) && 
		(Bots(NewEnemy) == None) &&
		(Bot(NewEnemy) == None))
		return false;

	noOldEnemy = (Enemy == None);
	result = false;
	newAttitude = AttitudeTo(NewEnemy);
	if ( !noOldEnemy )
	{
		if (Enemy == NewEnemy)
			return true;
		else if ( NewEnemy.bIsPlayer && (AlarmTag != '') )
		{
			OldEnemy = Enemy;
			Enemy = NewEnemy;
			result = true;
		} 
		else if ( newAttitude == ATTITUDE_Friendly )
		{
			if ( bIgnoreFriends )
				return false;
			if ( (NewEnemy.Enemy != None) && (NewEnemy.Enemy.Health > 0) ) 
			{
				if ( NewEnemy.Enemy.bIsPlayer && (NewEnemy.AttitudeToPlayer < AttitudeToPlayer) )
					AttitudeToPlayer = NewEnemy.AttitudeToPlayer;
				if ( AttitudeTo(NewEnemy.Enemy) < AttitudeTo(Enemy) )
				{
					OldEnemy = Enemy;
					Enemy = NewEnemy.Enemy;
					result = true;
				}
			}
		}
		else 
		{
			oldAttitude = AttitudeTo(Enemy);
			if ( (newAttitude < oldAttitude) || 
				( (newAttitude == oldAttitude) 
					&& ((VSize(NewEnemy.Location - Location) < VSize(Enemy.Location - Location)) 
						|| !LineOfSightTo(Enemy)) ) ) 
			{
				if ( bIsPlayer && Enemy.IsA('PlayerPawn') && !NewEnemy.IsA('PlayerPawn') )
				{
					newStrength = relativeStrength(NewEnemy);
					if ( (newStrength < 0.2) && (relativeStrength(Enemy) < FMin(0, newStrength))  
						&& (IsInState('walking')) && (Level.TimeSeconds - HuntStartTime < 5) )
						result = false;
					else
					{
						result = true;
						OldEnemy = Enemy;
						Enemy = NewEnemy;
					}
				} 
				else
				{
					result = true;
					OldEnemy = Enemy;
					Enemy = NewEnemy;
				}
			}
		}
	}
	else if ( newAttitude < ATTITUDE_Ignore )
	{
		result = true;
		Enemy = NewEnemy;
	}
	else if ( newAttitude == ATTITUDE_Friendly )
	{	
		if ( NewEnemy.bIsPlayer && (AlarmTag != '') )
		{
			Enemy = NewEnemy;
			result = true;
		} 
		if (bIgnoreFriends)
			return false;

		if ( (NewEnemy.Enemy != None) && (NewEnemy.Enemy.Health > 0) ) 
		{
			result = true;
			Enemy = NewEnemy.Enemy;
			if (Enemy.bIsPlayer)
				AttitudeToPlayer = ScriptedPawn(NewEnemy).AttitudeToPlayer;
			else if ( (ScriptedPawn(NewEnemy) != None) && (ScriptedPawn(NewEnemy).Hated == Enemy) )
				Hated = Enemy;
		}
	}

	if ( result )
	{
		LastSeenPos = Enemy.Location;
		LastSeeingPos = Location;
		EnemyAcquired();
		if ( !bFirstHatePlayer && Enemy.bIsPlayer && (FirstHatePlayerEvent != '') )
			TriggerFirstHate();
	}
	else if ( NewEnemy.bIsPlayer && (NewAttitude < ATTITUDE_Threaten) )
		OldEnemy = NewEnemy;
				
	return result;
}

function eAttitude AttitudeTo(Pawn Other)
{
	if(PlayerReplicationInfo.Team != 255 &&
			PlayerReplicationInfo.Team == Other.PlayerReplicationInfo.Team)
		return ATTITUDE_Friendly;

	if(bHateOurOwn && Other.class == class)
	{
		return ATTITUDE_Hate;
	}

	return Super.AttitudeTo(Other);
}

function BotVoiceMessage(name messagetype, byte MessageID, Pawn Sender)
{
	if ( messagetype == 'ORDER' )
	{
		
	}
}

State Destroying
{
ignores SeePlayer, EnemyNotVisible, HearNoise, KilledBy, Trigger, Bump, HitWall, HeadZoneChange, FootZoneChange, ZoneChange, Falling, WarnTarget, Died, LongFall, PainTimer;

	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
							Vector momentum, name damageType)
	{
		if ( bDeleteMe )
			return;
		Health = Health - Damage;
		Momentum = Momentum/Mass;
		AddVelocity( momentum ); 
		if ( !bHidden && Gibbed(damageType) )
		{
			bHidden = true;
			SpawnGibbedCarcass();
			if ( bIsPlayer )
				Destroy();
			else
				Destroy();
		}
	}

	function Timer()
	{
Destroy();
		if ( !bHidden )
		{
			bHidden = true;
			SpawnCarcass();
			if ( bIsPlayer )
				Destroy();
			else
				Destroy();
		}
	}

	event Landed(vector HitNormal)
	{
		SetPhysics(PHYS_None);
	}

	function BeginState()
	{
		SetTimer(0.3, false);
	}
}

function bool RestartTitan( pawn aPlayer )	
{
	local bool foundStart;

	if( startPoint == None )
	{
		log(class$"::RestartPlayer : startPoint = None!");
		return false;
	}

	foundStart = aPlayer.SetLocation(startPoint.Location);
	if( foundStart )
	{
		startPoint.PlayTeleportEffect(aPlayer, true);
		aPlayer.SetRotation(startPoint.Rotation);
		aPlayer.ViewRotation = aPlayer.Rotation;
		aPlayer.Acceleration = vect(0,0,0);
		aPlayer.Velocity = vect(0,0,0);
		aPlayer.Health = aPlayer.Default.Health;
		aPlayer.SetCollision( true, true, true );
		aPlayer.ClientSetLocation( startPoint.Location, startPoint.Rotation );
		aPlayer.bHidden = false;
		aPlayer.DamageScaling = aPlayer.Default.DamageScaling;
		aPlayer.SoundDampening = aPlayer.Default.SoundDampening;
		SetInventory();
	}
	else
		log(startPoint$" Player start not useable!!!");

	return foundStart;
}

state Dying
{
ignores SeePlayer, EnemyNotVisible, HearNoise, Died, Bump, Trigger, HitWall, HeadZoneChange, FootZoneChange, ZoneChange, Falling, WarnTarget, LongFall, SetFall, PainTimer;

	function ReStartPlayer()
	{
		if( bHidden && RestartTitan(self) )
		{
			Velocity = vect(0,0,0);
			Acceleration = vect(0,0,0);
			ViewRotation = Rotation;
			SetPhysics(PHYS_Falling);
			GotoState('Roaming');
		}
		else if ( !IsInState('GameEnded') )
			GotoState('Dying', 'TryAgain');
	}

Begin:
	if ( Level.Game.bGameEnded )
		GotoState('GameEnded');
	Sleep(0.2);

	if(!bRespawn)
		GotoState('Destroying');

	if ( !bHidden )
		SpawnCarcass();
TryAgain:
	if ( !bHidden )
		HidePlayer();
	Sleep(RespawnDelay);
	ReStartPlayer();
	Goto('TryAgain');
WaitingForStart:
	bHidden = true;
}

defaultproperties
{
     meleeteamvaluemonster=255
     Team=3
     scorevalue=1
}
