class MM_SilverImprovementTool expands MM_SilverMonsterTool;

event float BotDesireability( pawn Bot )
{
	local inventory Inv;

	for ( Inv=Bot.inventory; Inv!=None; Inv=Inv.inventory )
		if ( Inv.IsA('MM_SilverImprovementTool') )
			return -1;

	return Super.BotDesireability(Bot);
}

function BeginState()
	{
		bActive = true;
SetTimer(5.0, true);

}
function Timer()
{
	if (pawn(owner).health<0) Destroy();
}

function ArmorImpactEffect(vector HitLocation)
{ 
	if ( Owner.IsA('PlayerPawn') )
	{
		PlayerPawn(Owner).ClientFlash(-0.05,vect(400,400,400));
		PlayerPawn(Owner).PlaySound(DeActivateSound, SLOT_None, 2.7*PlayerPawn(Owner).SoundDampening);
	}
}

function PickupFunction(Pawn Other)
{
	local Inventory Inv;

        inv = instigator.FindInventoryType(class'MM_SilverBerserkerTool');
   	 
		if( inv != None )
		{
				inv.destroy();
              PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Silver' @ 'Berserker' @ 'Tool'$M_DeActivated$ItemName);	
		}

        inv = instigator.FindInventoryType(class'MM_SilverLifeTool');
   	 
		if( inv != None )
		{
				inv.destroy();
              PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Silver' @ 'Life' @ 'Tool'$M_DeActivated$ItemName);	
		}

        inv = instigator.FindInventoryType(class'MM_SilverNaliSpiritTool');
   	 
		if( inv != None )
		{
				inv.destroy();
               PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Silver' @ 'Nali' @ 'Spirit' @ 'Tool'$M_DeActivated$ItemName);	
		}

        inv = instigator.FindInventoryType(class'MM_SilverProjectileDamageTool');
   	 
		if( inv != None )
		{
				inv.destroy();
              PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Silver' @ 'Projectile' @ 'Damage' @ 'Tool'$M_DeActivated$ItemName);	
		}

        inv = instigator.FindInventoryType(class'MM_SilverProjectileSpeedTool');
   	 
		if( inv != None )
		{
				inv.destroy();
              PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Silver' @ 'Projectile' @ 'Speed' @ 'Tool'$M_DeActivated$ItemName);	
		}

        inv = instigator.FindInventoryType(class'MM_SilverSpeedTool');
   	 
		if( inv != None )
		{
				inv.destroy();
               PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Silver' @ 'Speed' @ 'Tool'$M_DeActivated$ItemName);	
		}
        inv = instigator.FindInventoryType(class'MM_SilverMonsterCreditTool');
   	 
		if( inv != None )
		{
				inv.destroy();
               PlaySound(sound'unrealshare.beep',, 2.0);
               Pawn(Owner).ClientMessage(M_Activated$'Silver' @ 'Speed' @ 'Tool'$M_DeActivated$ItemName);	
		}
        		if( inv == None )
		{
			  Pawn(Owner).ClientMessage(M_Selected$ItemName);	
		}
}

defaultproperties
{
     bAutoActivate=True
     PickupMessage="You picked up the Silver Improvement Tool."
     ItemName="Silver Improvement Tool"
     PlayerViewMesh=LodMesh'UnrealShare.MonkStatueM'
     PickupViewMesh=LodMesh'UnrealShare.MonkStatueM'
     M_Activated="You replaced the "
     Mesh=LodMesh'UnrealShare.MonkStatueM'
     CollisionHeight=20.000000
}
