class SDemoEnhacer expands Actor;


simulated function Tick(float Delta)
{
	local Class<GameInfo> GameClass;
	local Class<ScoreBoard> SBClass;
	local Class<HUD> HUDClass;
	local DemoRecSpectator DRS;
	local int Count;

	foreach AllActors(class'DemoRecSpectator', DRS)
		{
		if (DRS.PlaybackActor != None && DRS.PlaybackGRI != None)
			{
			GameClass=Class<GameInfo>(DynamicLoadObject(DRS.PlaybackGRI.GameClass,Class'Class'));
			SBClass=None;
			switch (GameClass.Default.ScoreBoardType)
				{
				Case Class'TeamScoreBoard':		SBClass = Class'MMScoreBoard';
									break;			
				}

			if (SBClass == None) 
				{
				//log("SUtils: Failed to load SScoreBoard!");
				}
			else if (SBClass != DRS.PlaybackActor.ScoringType)
				{
				DRS.PlaybackActor.ScoringType=SBClass;
				if ( DRS.PlaybackActor.Scoring != None )
					DRS.PlaybackActor.Scoring.Destroy();
				DRS.PlaybackActor.Scoring=None;
				}

			if ( HUDClass == None)
				HUDClass=Class<HUD>(DynamicLoadObject(string(GameClass.Default.HUDType),Class'Class'));
			if ( HUDClass == None )
				{
				log("SUtils: Failed to load HUD!");
				}
			else if(HUDClass != DRS.PlaybackActor.HUDType)
				{
				DRS.PlaybackActor.HUDType=HUDClass;
				if ( DRS.PlaybackActor.myHUD != None )
					DRS.PlaybackActor.myHUD.Destroy();
				DRS.PlaybackActor.myHUD=None;
				}
			Destroy();
			}
		Count++;
		}

	if (Count == 0)
		Destroy();
}
			
			

defaultproperties
{
    Texture=None
}
