class SPRI expands ReplicationInfo;

var byte ShowBonusInfo;
var int Info,Accuracy;

var string CountryPrefix;
var actor IpToCountry;

var string CountryFlagsPackage;

replication
{
	reliable if ( Role == ROLE_Authority )
		ShowBonusInfo, Info, Accuracy, CountryPrefix;
	reliable if (Role == ROLE_Authority && bNetInitial)
		CountryFlagsPackage;
}


function PostBeginPlay()
{
	//log("POSTBEGIN");
	Timer();
	SetTimer(2.0, true);
}

function Timer()
{
	local PlayerPawn P;
	local string temp;
	//log("TIME");
	if (Owner == None)
	{
		//log("DESTROY ? O_o");
		Destroy();
		return;
	}
	//log("TIMER");

	if(IpToCountry != None)
	{
		//log("TIMER2");
		if(CountryPrefix == "")
		{
			//log("TIMER3");
			P=PlayerPawn(Owner.Owner); // owner is playerreplicationinfo, owner.owner must be player then
			if(NetConnection(P.Player) != None)
			{
				temp=P.GetPlayerNetworkAddress();
				temp=Left(temp, InStr(temp, ":"));
				temp=IpToCountry.GetItemName(temp);
		
				if(temp == "!Disabled") /* after this return, iptocountry won't resolve anything anyway */
					IpToCountry=None;
				else if(Left(temp, 1) != "!") /* good response */
				{
					CountryPrefix=SelElem(temp, 5);
					//log("FOUND COUNTRY PREFIX");
					if(CountryPrefix=="") /* the country is probably unknown(maybe LAN), so as the prefix */
						IpToCountry=None;
				}
			}
			else
				IpToCountry=None;
		}
		else
			IpToCountry=None;
	}

	if (Pawn(Owner.Owner).IsA('PlayerPawn') && PlayerPawn(Owner.Owner).player != None)
		P = PlayerPawn(Owner.Owner);

	if (ShowBonusInfo == 1)
	{
		if (Pawn(Owner.Owner).IsA('PlayerPawn') && PlayerPawn(Owner.Owner).player != None)
			Info=Clamp(PlayerPawn(Owner.Owner).player.CurrentNetSpeed, 0, 50000);
		else
			Info=0;
	}
	else if (ShowBonusInfo == 2)
	{
		Info = Clamp(int((float(Pawn(Owner.Owner).KillCount) / float(Pawn(Owner.Owner).KillCount+Pawn(Owner.Owner).DieCount)) * 100), 0, 100);
	}
}

static final function string SelElem(string Str, int Elem, optional string Char)
{
	local int pos, count;
	if(Char=="")
		Char=":";

	while( (Elem--) >1)
	{
		pos=InStr(Str, Char);
		if(pos != -1)
			Str=Mid(Str, pos+1);
		else
			return "";
	}
	pos=InStr(Str, Char);
	if(pos != -1)
    	return Left(Str, pos);
	else
		return Str;
}

defaultproperties
{
}
